package redis_lock

import (
	"code.gitea.io/gitea/modules/redis/redis_client"
	"time"
)

type DistributeLock struct {
}

func NewDistributeLock() *DistributeLock {
	return &DistributeLock{}
}

func (lock *DistributeLock) Lock(lockKey string, expireTime time.Duration) bool {
	isOk, _ := redis_client.Setnx(lockKey, "", expireTime)
	return isOk
}

func (lock *DistributeLock) LockWithWait(lockKey string, expireTime time.Duration, waitTime time.Duration) bool {
	start := time.Now().Unix() * 1000
	duration := waitTime.Milliseconds()
	for {
		isOk, _ := redis_client.Setnx(lockKey, "", expireTime)
		if isOk {
			return true
		}
		if time.Now().Unix()*1000-start > duration {
			return false
		}
		time.Sleep(50 * time.Millisecond)
	}

	return false
}

func (lock *DistributeLock) UnLock(lockKey string) error {
	_, err := redis_client.Del(lockKey)
	return err
}
